#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#define HEAD_SIZE 816

double read_head(int file,struct tm *tm) { 
  double time=-1; 
  static char *s=NULL,*c;
  static int s_length, nread;
 
  if (!s) {s_length=HEAD_SIZE;if (s_length<80) s_length=80;
           s=(char *) malloc(s_length);
	   c=(char *) malloc(10);}
  nread = read(file,s,16);
  if (strncmp(s,"200",3)==0) { // Starting with timestamp
    strncpy(c,s,4); c[4]=0;tm->tm_year=atoi(c);
    strncpy(c,s+4,2);c[2]=0;tm->tm_mon=atoi(c);
    strncpy(c,s+6,2);c[2]=0;tm->tm_mday=atoi(c);
    strncpy(c,s+9,2);c[2]=0;tm->tm_hour=atoi(c);
    strncpy(c,s+11,2);c[2]=0;tm->tm_min=atoi(c);
    strncpy(c,s+13,2);c[2]=0;tm->tm_sec=atoi(c);
    time=tm->tm_hour+(tm->tm_min+tm->tm_sec/60E0)/60E0;
    nread = read(file,s,s_length);
    lseek(file,-s_length,SEEK_CUR);
    s_length=16;
  }
  if (strncmp(s,"$HEAD_SIZE",10)==0) { // Starting with new header
    sscanf(s,"$HEAD_SIZE%d",&s_length); // get the length
    if (s_length>0 && s_length<1e4) { 
    if (time>=0) {s_length+=16;} // extra time stamp 

    s=realloc(s,s_length); // correct length
    lseek(file,0,SEEK_SET); // rewind
    nread = read(file,s,s_length); // read the whole header
    c=strstr(s,"START");
    if (c) {
      c=c+6;while ((int) (c-s)<s_length && c[0]==' ') c++;
      if (c[0]=='2') { 
	strncpy(c,s,4); c[4]=0;tm->tm_year=atoi(c);
	strncpy(c,s+4,2);c[2]=0;tm->tm_mon=atoi(c);
	strncpy(c,s+6,2);c[2]=0;tm->tm_mday=atoi(c);
	strncpy(c,s+9,2);c[2]=0;tm->tm_hour=atoi(c);
	strncpy(c,s+11,2);c[2]=0;tm->tm_min=atoi(c);
	strncpy(c,s+13,2);c[2]=0;tm->tm_sec=atoi(c);
	time=tm->tm_hour+(tm->tm_min+tm->tm_sec/60E0)/60E0;
      } else c=NULL; /*not this century*/ }}
  } // Not new header

  if (!c || s_length<0 || s_length>1e4 || time <0) { 
    fprintf(stderr,
	    "Failed to read header correctly\n%s\n"
	    "did not produce a sensible header size: %d\n",
	    s,s_length); 
    exit(1); 
  } 

  return(time);
}
    
